{---------------------------------------------------------------
 |      x_strg : module for special string operations          |
 |      ======                                                 |
 |                                                             |
 |      Procedures : x_release(s)                              |
 ---------------------------------------------------------------}
MODULE x_strg;

{---------------------------------------------------------------
 |      x_release : the unused portion of a string variable    |
 |      =========   with unspecified length is released.       |
 ---------------------------------------------------------------}
GLOBAL PROCEDURE x_release ( VAR s : STRING );
   VAR d : STRING;
   PROCEDURE free ( VAR s : STRING ); EXTERNAL s_free;
BEGIN
   IF MAXLENGTH(s)=MAXINT THEN
   BEGIN
      d := s;
      free(s);
      s := d;
   END;
END;

END.
