/**********************************************************************/
/*                                                                    */
/*   "DP_GENTY.H"                                                     */
/*                                                                    */
/*   Last change    == Oct-26-93 ==                                   */
/*        A.Just / R.Hammer                                           */
/*                                                                    */
/* This file contains the type definitions, with both modules         */
/* "DP_GEN1.C" and "DP_GEN_2.C" use.                                  */
/*                                                                    */
/* Jun-27-91 Just : element 'pre_add' added to struc 'tVARINFO'       */
/* Oct-26-93 Just : element 'mat_transp' added to struc 'tVARINFO'    */
/*                                                                    */
/**********************************************************************/



     /*---------------------------------------------------------------*/
     /* used for passing parameters to the following functions:       */
     /*             d_goperand     ();                                */
     /*             d_gvarelem     ();                                */
     /*             d_gfuncelem    ();                                */
     /*             d_gfuncarg     ();                                */
     /*             d_gidcall      ();                                */
     /*---------------------------------------------------------------*/

typedef struct {
          tSTRUCTYPE     struc;
          tARITHTYPE     base;
          symptr         c_symptr,i_symptr;
          union {
               tVARBLK   *varptr;
               binptr    binvar;
               }ptr;
          binptr         row,col;
          binptr         pre_add;
          boolean        undeclare;
          boolean        id_opt;
          boolean        mat_transp;
          } tVARINFO;



/**************************************************************************/



     /*---------------------------------------------------------------*/
     /* used to pass paramter for 'id()'-optimization to function     */
     /* 'd_gaddition()'                                               */
     /*---------------------------------------------------------------*/

typedef struct {
          boolean   r_opt,l_opt;
          binptr    row,col;
          } tOPTBLK;
