Name:      pxsc
Summary:   A Pascal to C Compiler for Extended Scientific Computing 
Version:   3.6.2
Release:   3.7
License:   GPL
Group:     Development/Libraries
Vendor:    Bergische Universitaet Wuppertal
URL:       http://www.xsc.de/
Source:    %{name}-3.6.2.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-build
Provides:  pxsc-3.6.2
Prefix:    /usr/local/p-xsc


%description
P-XSC, a Pascal to C Compiler for Extended Scientific Computing 

Authors:
--------
    Boris Hoeffgen <hoeffgen@uni-wuppertal.de>
    Werner Hofschuster <hofschuster@math.uni-wuppertal.de>

%prep
%setup -q

%build
make all

%install
make install
rm -rf %{buildroot}
mkdir %{buildroot}
mkdir %{buildroot}/usr
mkdir %{buildroot}/usr/local
mkdir %{buildroot}/usr/local/p-xsc
cp -r %{prefix}/* %{buildroot}/usr/local/p-xsc/

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr (-, root, root)
%{prefix}/Toolbox
%{prefix}/awa
%{prefix}/bin
%{prefix}/example
%{prefix}/sys
%{prefix}/user

%post
if [ $UID != 0 ] ; then
    SYSPATH=`grep PXSC_SYS ~/.bashrc`
    if [ -z $SYSPATH ] ; then
        echo "PXSC_SYS=/usr/local/p-xsc/sys/; export PXSC_SYS" >> ~/.bashrc
        echo "PATH=\$PATH:/usr/local/p-xsc/bin/; export PATH" >> ~/.bashrc
    fi
    else
    if [ -e /etc/profile.local ] ; then
        SYSPATH=`grep PXSC_SYS /etc/profile.local`
        if [ -z $SYSPATH ] ; then
        echo "PXSC_SYS=/usr/local/p-xsc/sys/; export PXSC_SYS" >> /etc/profile.local
        echo "PATH=\$PATH:/usr/local/p-xsc/bin/; export PATH" >> /etc/profile.local
    fi
    else
        echo "#!/bin/sh" >> /etc/profile.local
        echo "PXSC_SYS=/usr/local/p-xsc/sys/; export PXSC_SYS" >> /etc/profile.local
        echo "PATH=\$PATH:/usr/local/p-xsc/bin/; export PATH" >> /etc/profile.local
    fi
fi
echo
echo "Installation Path: /usr/local/p-xsc"
echo "Please relogin to complete the installation!!!"
echo

%changelog
* Wed Dec 14 2005 - hoeffgen
- Problems with different Hashfunktions
- ANSI-C Prototypes
- Stdmod Problems 
* Wed Nov 30 2005 - werner
- initial release
